import React from 'react';
import ReactDOM from 'react-dom';
import './index.css';

class Square extends React.Component {
    //constructor(props) {
    //    super(props);
    //    this.state = {};
    //}

    render() {
      return (
        //we want to bake a function into this JSX so alert isn't called with every render
        //<button className="square" onClick={() => alert('click')}>
        //<button className="square" onClick={() => this.setState(this.props)}>
        <button 
          className="square" 
          //onClick={() => this.setState({value: 'X'})}
          onClick={() => this.props.clickfunc()}
        >
          {this.props.value}
        </button>
      );
    }
}
  
  class Board extends React.Component {
    constructor(props){
        super(props);
        this.state = {
            squares : Array(9).fill(null)
        }
    };

    handleClick(i) {
        const squares = this.state.squares.slice();
        squares[i] = 'X';
        this.setState({squares: squares});
    }

    renderSquare(i) {
      return (
        //all the stuff passed here are 'props', could be anything
        //we have an object and a function reference
          <Square 
            value={this.state.squares[i]} 
            //cannot pass the name of the function directly, but only a named refernce
            clickfunc={() => this.handleClick(i)}
            />
        );
      //return <Square value={i} />;
    }
  
    render() {
      const status = 'Next player: X';
  
      return (
        <div>
          <div className="status">{status}</div>
          <div className="board-row">
            {this.renderSquare(0)}
            {this.renderSquare(1)}
            {this.renderSquare(2)}
          </div>
          <div className="board-row">
            {this.renderSquare(3)}
            {this.renderSquare(4)}
            {this.renderSquare(5)}
          </div>
          <div className="board-row">
            {this.renderSquare(6)}
            {this.renderSquare(7)}
            {this.renderSquare(8)}
          </div>
        </div>
      );
    }
  }
  
  class Game extends React.Component {
    render() {
      return (
        <div className="game">
          <div className="game-board">
            <Board />
          </div>
          <div className="game-info">
            <div>{/* status */}</div>
            <ol>{/* TODO */}</ol>
          </div>
        </div>
      );
    }
  }
  
  // ========================================
  
  ReactDOM.render(
    <Game />,
    document.getElementById('root')
  );
  
